> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://virtuous.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://virtuous.ferndocs.com/_mcp/server.

# Update an existing donor (full update).

PUT https://prod-api.raisedonors.com/api/Donor/{id}
Content-Type: application/json

This endpoint performs a full update of the donor record. All fields in the request will replace existing values.
To update only specific fields, use the PATCH endpoint instead.

Reference: https://virtuous.ferndocs.com/reference/raise/donor/updatedonor

## Authentication

- `Authorization` header (required) — JWT Authorization header using the Bearer scheme. Example: "Authorization: Bearer \{token}"

## Request

### Path parameters

- `id` (long, required) — The ID of the donor to update.

### Body (application/json)

This endpoint expects a Donor_updatedonor_Request.

- `Donor_updatedonor_Request`
  - DonorRequest: DonorRequest
  - CreateDonorRequest: CreateDonorRequest

## Response

### 200

OK

- `id` (long, optional) — Gets or sets the identifier.
- `name` (string, optional, nullable) — Gets or sets the name.
- `title` (string, optional, nullable) — Gets or sets the title.
- `firstName` (string, optional, nullable) — Gets or sets the first name.
- `middleName` (string, optional, nullable) — Gets or sets the middle name.
- `lastName` (string, optional, nullable) — Gets or sets the last name.
- `suffix` (string, optional, nullable) — Gets or sets the suffix.
- `email` (string, optional, nullable) — Gets or sets the email address.
- `phone` (string, optional, nullable) — Gets or sets the phone.
- `createdDate` (string, optional, nullable) — Gets or sets the created date.
- `modifiedDate` (string, optional, nullable) — Gets or sets the modified date.
- `notes` (string, optional, nullable) — Gets or sets any additional notes.
- `isOrganization` (boolean, optional) — Gets or sets a value indicating whether organization.
- `organizationName` (string, optional, nullable) — Gets or sets the organization name.
- `crmKeyUrls` (map from string to CrmUrlInfo, optional, nullable) — Gets or sets the CRM URLs by integration type.
- `crmKey` (string, optional, nullable) — Gets or sets the crmkey.
- `crmSecondKey` (string, optional, nullable) — Gets or sets the crmsecond key.
- `isTestMode` (boolean, optional) — Gets or sets a value indicating whether test mode.
- `isArchived` (boolean, optional) — Gets or sets a value indicating whether archived.
- `isGDPRDeleted` (boolean, optional) — Gets or sets a value indicating whether gdprdeleted.
- `primaryAddress` (DonorAddressModel, optional, nullable) — Gets or sets the address.
- `donorAddresses` (list of DonorAddressModel, optional, nullable) — Gets or sets the donor addresses.
- `donorEmailAddresses` (list of DonorContactMethodModel, optional, nullable) — Gets or sets the donor email addresses.
- `donorPhoneNumbers` (list of DonorContactMethodModel, optional, nullable) — Gets or sets the donor phone numbers.

## Errors

### 400 Bad Request Error

Bad Request

- `Donor_UpdateDonorRequestBadRequestError`
  - ProblemDetails: ProblemDetails
  - HttpValidationProblemDetails: HttpValidationProblemDetails

### 404 Not Found Error

Not Found

- `Donor_UpdateDonorRequestNotFoundError`
  - ProblemDetails: ProblemDetails
  - HttpValidationProblemDetails: HttpValidationProblemDetails

## Types

### DonorRequest

Represents a donor request.

- `firstName` (string, required)
- `lastName` (string, required)
- `title` (string, optional, nullable)
- `middleName` (string, optional, nullable)
- `suffix` (string, optional, nullable)
- `email` (string, optional, nullable)
- `phone` (string, optional, nullable)
- `notes` (string, optional, nullable) — Gets or sets any additional notes.
- `isOrganization` (boolean, optional) — Gets or sets a value indicating whether organization.
- `organizationName` (string, optional, nullable)
- `crmKey` (string, optional, nullable) — Gets or sets the crmkey.
- `crmKeys` (map from string to string, optional, nullable) — Gets or sets the CRM keys.

### CreateDonorRequest

Represents a request to create a donor.

- `firstName` (string, required)
- `lastName` (string, required)
- `crmKey` (string, optional, nullable) — Gets or sets the crmkey.
- `crmKeys` (map from string to string, optional, nullable) — Gets or sets the CRM keys.
- `donorAddresses` (list of CreateDonorRequestDonorAddressesItems, optional, nullable) — Gets or sets the list of donor addresses.
- `donorEmailAddresses` (list of ContactMethodRequest, optional, nullable) — Gets or sets the list of donor email addresses.
- `donorPhoneNumbers` (list of ContactMethodRequest, optional, nullable) — Gets or sets the list of donor phone numbers.
- `email` (string, optional, nullable)
- `isOrganization` (boolean, optional) — Gets or sets a value indicating whether organization.
- `middleName` (string, optional, nullable)
- `notes` (string, optional, nullable) — Gets or sets any additional notes.
- `organizationName` (string, optional, nullable)
- `phone` (string, optional, nullable)
- `suffix` (string, optional, nullable)
- `title` (string, optional, nullable)

### CrmUrlInfo

- `crmKey` (string, optional, nullable)
- `url` (string, optional, nullable)

### DonorAddressModel

Represents a donoraddress model.

- `address1` (string, optional, nullable) — Gets or sets the address1.
- `address2` (string, optional, nullable) — Gets or sets the address2.
- `addressType` (enum, optional) — Gets or sets the address type.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`
- `addressTypeDisplay` (string, optional, nullable) — Gets or sets the address type display.
- `city` (string, optional, nullable) — Gets or sets the city name.
- `countryString` (string, optional, nullable) — Gets or sets the country string.
- `donorId` (long, optional) — Gets or sets the donor identifier.
- `id` (long, optional) — Gets or sets the identifier.
- `isPrimary` (boolean, optional) — Gets or sets whether this is the primary address for the donor.
- `postal` (string, optional, nullable) — Gets or sets the postal or ZIP code.
- `state` (string, optional, nullable) — Gets or sets the state or province.

### DonorContactMethodModel

Represents a donorcontactmethod model.

- `id` (long, optional) — Gets or sets the identifier.
- `donorId` (long, optional) — Gets or sets the donor identifier.
- `type` (enum, optional) — Gets or sets the type.
  - Allowed values: `0`, `10`, `11`, `12`, `20`, `21`, `22`, `99`
- `typeDisplay` (string, optional, nullable) — Gets or sets the type display.
- `value` (string, optional, nullable) — Gets or sets the value.
- `secondaryValue` (string, optional, nullable) — Gets or sets the secondary value.
- `isPrimary` (boolean, optional) — Gets or sets a value indicating whether primary.
- `isOptedIn` (boolean, optional) — Gets or sets a value indicating whether opted in.
- `isValid` (boolean, optional) — Gets or sets the isval identifier.
- `isEmail` (boolean, optional) — Gets or sets the is email address.
- `isPhone` (boolean, optional) — Gets or sets a value indicating whether phone.
- `isBounced` (boolean, optional) — Gets or sets a value indicating whether bounced.
- `countryCode` (string, optional, nullable) — Gets or sets the country code.

### ProblemDetails

- `type` (string, optional, nullable)
- `title` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `detail` (string, optional, nullable)
- `instance` (string, optional, nullable)

### HttpValidationProblemDetails

- `detail` (string, optional, nullable)
- `errors` (map from string to list of string, optional, nullable)
- `instance` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `title` (string, optional, nullable)
- `type` (string, optional, nullable)

### CreateDonorRequestDonorAddressesItems

Represents an address request.

- AddressRequest: AddressRequest
- DonorAddressRequest: DonorAddressRequest

### ContactMethodRequest

Represents a contactmethod request.

- `type` (enum, required)
  - Allowed values: `0`, `10`, `11`, `12`, `20`, `21`, `22`, `99`
- `isPrimary` (boolean, required)
- `value` (string, optional, nullable)
- `isEmail` (boolean, optional) — Gets or sets the is email address.
- `isPhone` (boolean, optional) — Gets or sets a value indicating whether phone.
- `isOptedIn` (boolean, optional) — Gets or sets a value indicating whether opted in.
- `countryCode` (string, optional, nullable) — Gets or sets the country code.

### AddressRequest

Represents an address request.

- `address1` (string, optional, nullable) — Gets or sets the first line of the address.
- `address2` (string, optional, nullable) — Gets or sets the second line of the address.
- `city` (string, optional, nullable) — Gets or sets the city of the address.
- `state` (string, optional, nullable) — Gets or sets the state of the address.
- `postal` (string, optional, nullable) — Gets or sets the postal code of the address.
- `countryString` (string, optional, nullable) — Gets or sets the country of the address as a string.
- `addressType` (enum, optional) — Gets or sets the type of the address.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`

### DonorAddressRequest

Represents an address request.

- `address1` (string, optional, nullable) — Gets or sets the first line of the address.
- `address2` (string, optional, nullable) — Gets or sets the second line of the address.
- `addressType` (enum, optional) — Gets or sets the type of the address.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`
- `city` (string, optional, nullable) — Gets or sets the city of the address.
- `countryString` (string, optional, nullable) — Gets or sets the country of the address as a string.
- `donorId` (long, optional) — Gets or sets the donor identifier.
- `id` (long, optional) — Gets or sets the identifier.
- `isPrimary` (boolean, optional) — Gets or sets whether this is the primary address for the donor.
- `postal` (string, optional, nullable) — Gets or sets the postal code of the address.
- `state` (string, optional, nullable) — Gets or sets the state of the address.

## Examples

**Request**

```json
{
  "firstName": "Emily",
  "lastName": "Johnson"
}
```

**Response**

```json
{
  "id": 12345,
  "name": "Emily Johnson",
  "title": "Ms.",
  "firstName": "Emily",
  "middleName": "Grace",
  "lastName": "Johnson",
  "suffix": "Jr.",
  "email": "emily.johnson@example.com",
  "phone": "+1-555-123-4567",
  "createdDate": "2023-11-10T09:15:00Z",
  "modifiedDate": "2024-04-20T14:30:00Z",
  "notes": "Preferred contact time: afternoons.",
  "isOrganization": false,
  "organizationName": "Johnson Family Foundation",
  "crmKeyUrls": {},
  "crmKey": "CRM-EMJ-2023",
  "crmSecondKey": "SEC-EMJ-2023",
  "isTestMode": false,
  "isArchived": false,
  "isGDPRDeleted": false,
  "primaryAddress": {
    "address1": "123 Maple Street",
    "address2": "Apt 4B",
    "addressType": 1,
    "addressTypeDisplay": "Home",
    "city": "Springfield",
    "countryString": "USA",
    "donorId": 12345,
    "id": 987,
    "isPrimary": true,
    "postal": "62704",
    "state": "IL"
  },
  "donorAddresses": [
    {
      "address1": "123 Maple Street",
      "address2": "Apt 4B",
      "addressType": 1,
      "addressTypeDisplay": "Home",
      "city": "Springfield",
      "countryString": "USA",
      "donorId": 12345,
      "id": 987,
      "isPrimary": true,
      "postal": "62704",
      "state": "IL"
    }
  ],
  "donorEmailAddresses": [
    {
      "id": 555,
      "donorId": 12345,
      "type": 10,
      "typeDisplay": "Personal Email",
      "value": "emily.johnson@example.com",
      "secondaryValue": "",
      "isPrimary": true,
      "isOptedIn": true,
      "isValid": true,
      "isEmail": true,
      "isPhone": false,
      "isBounced": false,
      "countryCode": "US"
    }
  ],
  "donorPhoneNumbers": [
    {
      "id": 556,
      "donorId": 12345,
      "type": 20,
      "typeDisplay": "Mobile",
      "value": "+1-555-123-4567",
      "secondaryValue": "",
      "isPrimary": true,
      "isOptedIn": true,
      "isValid": true,
      "isEmail": false,
      "isPhone": true,
      "isBounced": false,
      "countryCode": "US"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://prod-api.raisedonors.com/api/Donor/1"

payload = {
    "firstName": "Emily",
    "lastName": "Johnson"
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://prod-api.raisedonors.com/api/Donor/1';
const options = {
  method: 'PUT',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"firstName":"Emily","lastName":"Johnson"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://prod-api.raisedonors.com/api/Donor/1"

	payload := strings.NewReader("{\n  \"firstName\": \"Emily\",\n  \"lastName\": \"Johnson\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://prod-api.raisedonors.com/api/Donor/1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"firstName\": \"Emily\",\n  \"lastName\": \"Johnson\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://prod-api.raisedonors.com/api/Donor/1")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"firstName\": \"Emily\",\n  \"lastName\": \"Johnson\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://prod-api.raisedonors.com/api/Donor/1', [
  'body' => '{
  "firstName": "Emily",
  "lastName": "Johnson"
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://prod-api.raisedonors.com/api/Donor/1");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"firstName\": \"Emily\",\n  \"lastName\": \"Johnson\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "firstName": "Emily",
  "lastName": "Johnson"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://prod-api.raisedonors.com/api/Donor/1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```